﻿using Hotline.Repository.SqlSugar.DataPermissions;
using SqlSugar;
using XF.Domain.Entities;

namespace Hotline.Repository.SqlSugar
{
    public static class DataPermissionExtensions
    {
        public static ISugarQueryable<TEntity> DataPermissionFiltering<TEntity>(this ISugarQueryable<TEntity> queryable, IDataPermissionFilterBuilder dataPermissionFilterBuilder)
            where TEntity : class, IEntity<string>, IDataPermission, new()
        {
            return queryable.Where(dataPermissionFilterBuilder.Build<TEntity>());
        }

        public static ISugarQueryable<TEntity> WorkflowDataFiltering<TEntity>(this ISugarQueryable<TEntity> queryable, IDataPermissionFilterBuilder dataPermissionFilterBuilder)
            where TEntity : class, IEntity<string>, IDataPermission, IWorkflow, new()
        {
            return queryable.Where(dataPermissionFilterBuilder.BuildIncludeFlowData<TEntity>());
        }

        public static TEntity InitDatePermission<TEntity>(this TEntity entity, IDataPermissionManager dataPermissionManager)
            where TEntity : class, IEntity<string>, IDataPermission, new()
        {
            var (orgId,departmentCode, creatorId, areaId) = dataPermissionManager.GetDataPermissionOptions();
            entity.CreateDataPermission(orgId,departmentCode, creatorId, areaId);
            return entity;
        }
    }
}
