﻿namespace Hotline.Share.Dtos.FlowEngine
{
    public class StepDto : StepBasicDto
    {
        public string Id { get; set; }

        public List<NextStepDto> NextSteps { get; set; }

        /// <summary>
        /// 被指派处理对象（依据不同指派方式可能为：depCode或userId）
        /// </summary>
        public string HandlerId { get; set; }

        public DateTime? StartTime { get; set; } = DateTime.Now;

        public DateTime? EndTime { get; set; }

        #region 审批参数

        /// <summary>
        /// (下一节点处理人)根据审批者类型不同，此字段为不同内容
        /// <example>
        /// 部门等级/分类为：depCodes, 角色为：userIds
        /// </example>
        /// </summary>
        public List<string> Handlers { get; set; }

        /// <summary>
        /// 下一节点code
        /// </summary>
        public string NextStepCode { get; set; }

        /// <summary>
        /// 是否短信通知
        /// </summary>
        public bool AcceptSms { get; set; }

        /// <summary>
        /// 办理意见
        /// </summary>
        public string Opinion { get; set; }

        #endregion

        public string PreviousId { get; set; }

    }
}
