﻿using Hotline.Share.Enums.FlowEngine;

namespace Hotline.Share.Dtos.FlowEngine
{
    public class WorkflowDto
    {
        public DefinitionDto Definition { get; set; }

        /// <summary>
        /// 主节点，依据流转进度动态生成
        /// </summary>
        public List<StepBoxDto> StepBoxes { get; set; }

        public DateTime? CompleteTime { get; set; }

        public List<WorkflowTraceDto> Traces { get; set; }

        public EWorkflowStatus Status { get; set; }
    }

    public class StepBoxDto
    {
        public DateTime? StartTime { get; set; }

        public DateTime? EndTime { get; set; }

        public List<StepDto> Steps { get; set; }
    }

    public class WorkflowTraceDto : StepBasicDto
    {
        public string WorkflowId { get; set; }

        public string StepId { get; set; }

        public ApproverDto ApproverDto { get; set; }

        public bool IsBackward { get; set; }

        public DateTime? CreationTime { get; set; }
    }
}
