﻿using Hotline.Share.Enums.FlowEngine;
using SqlSugar;
using XF.Domain.Repository;

namespace Hotline.FlowEngine.Definitions;

public class Definition : CreationEntity
{
    /// <summary>
    /// 模板名称
    /// </summary>
    public string Name { get; set; }

    /// <summary>
    /// 模板编码(唯一索引)
    /// </summary>
    public string Code { get; set; }

    /// <summary>
    /// 草稿版本号 == 0
    /// </summary>
    public int Version { get; set; }

    public string Description { get; set; }

    [SugarColumn(ColumnDataType = "varchar(4000)", IsJson = true)]
    public List<StepDefine> Steps { get; set; } = new();

    public string ExternalName { get; set; }

    [SugarColumn(ColumnDataType = "varchar(4000)", IsNullable = true)]
    public string? ExternalData { get; set; }

    public EDefinitionStatus Status { get; set; }
}