﻿namespace Hotline.FlowEngine.Definitions
{
    public interface IDefinitionDomainService
    {
        /// <summary>
        /// 发布流程模板
        /// </summary>
        /// <param name="id"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task PublishAsync(string id, CancellationToken cancellationToken);
        Task PublishAsync(Definition definition, CancellationToken cancellationToken);

        Task<int> GetLastVersionAsync(string code, CancellationToken cancellationToken);
        Task<Definition?> GetLastVersionDefinitionAsync(string code, CancellationToken cancellationToken);

        /// <summary>
        /// 未开启的流程，查找第2个节点的模板配置信息，用作开启流程的传参
        /// </summary>
        /// <param name="definitionCode"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task<IReadOnlyList<NextStepDefine>> GetInitNextStepsAsync(string definitionCode, CancellationToken cancellationToken);
    }
}
