﻿using Hotline.FlowEngine.Definitions;
using Hotline.Share.Dtos.FlowEngine;

namespace Hotline.FlowEngine.Workflows
{
    public interface IWorkflowDomainService
    {
        /// <summary>
        /// 返回前一级
        /// </summary>
        /// <returns></returns>
        Task PreviousAsync(PreviousDto dto, CancellationToken cancellationToken);

        /// <summary>
        /// 前往下一级
        /// </summary>
        /// <returns></returns>
        Task NextAsync(ApproverDto dto, CancellationToken cancellationToken);

        ///// <summary>
        ///// 获取当前节点（针对某操作人的当前节点）
        ///// </summary>
        ///// <returns></returns>
        //Task<(StepBox, Step)> GetStepAsync(string workflowId, string depCode, string userId, CancellationToken cancellationToken);
        //(StepBox, Step) GetStep(List<StepBox> stepBoxes, string depCode, string userId);

        /// <summary>
        /// 获取可能前往的下一节点
        /// </summary>
        /// <returns></returns>
        Task<IReadOnlyList<NextStepDefine>> GetNextStepsAsync(QueryWorkflowDto dto, CancellationToken cancellationToken);

        Workflow CreateWorkflow(Definition definition, StartWorkflowDto initDto);

        void AddStartTrace(Workflow workflow, StartWorkflowDto dto);
    }
}
