﻿using Hotline.FlowEngine.Definitions;
using Hotline.Share.Enums.FlowEngine;
using SqlSugar;
using XF.Domain.Repository;

namespace Hotline.FlowEngine.Workflows;

public class Workflow : CreationEntity
{
    public string DefinitionId { get; set; }

    //public WorkflowPointer Pointer { get; set; }

    public DateTime? CompleteTime { get; set; }

    public EWorkflowStatus Status { get; set; }

    [Navigate(NavigateType.OneToOne, nameof(DefinitionId))]
    public Definition Definition { get; set; }

    /// <summary>
    /// 主节点，依据流转进度动态生成
    /// </summary>
    [Navigate(NavigateType.OneToMany, nameof(WorkflowStep.WorkflowId))]
    public List<WorkflowStep> StepBoxes { get; set; }

    [Navigate(NavigateType.OneToMany, nameof(WorkflowTrace.WorkflowId))]
    public List<WorkflowTrace> Traces { get; set; } = new();
}

//public class WorkflowPointer
//{
//    public WorkflowPointer(string stepId)
//    {
//        this.CurrentStepId = stepId;
//    }

//    /// <summary>
//    /// 主节点Id
//    /// </summary>
//    public string CurrentStepId { get; set; }

//    void Move(StepBasic step)
//    {
//        throw new NotImplementedException();
//    }

//    void Back()
//    {
//        throw new NotImplementedException();
//    }
//}