﻿using Hotline.FlowEngine.Definitions;
using SqlSugar;

namespace Hotline.FlowEngine.Workflows;

public class WorkflowTrace : StepBasicEntity
{
    public string WorkflowId { get; set; }

    public string StepId { get; set; }

    /// <summary>
    /// 根据审批者类型不同，此字段为不同内容
    /// <example>
    /// 部门等级/分类为：depCodes, 角色为：userIds
    /// </example>
    /// </summary>
    [SugarColumn(ColumnDataType = "varchar(4000)", IsJson = true)]
    public List<string> Handlers { get; set; }

    /// <summary>
    /// 下一节点code
    /// </summary>
    public string NextStepCode { get; set; }

    /// <summary>
    /// 是否短信通知
    /// </summary>
    public bool AcceptSms { get; set; }

    public bool IsBackward { get; set; }
    
    public string DepCode { get; set; }

    public string UserId { get; set; }

    /// <summary>
    /// 办理意见
    /// </summary>
    public string Opinion { get; set; }

    public DateTime? CreationTime { get; set; } = DateTime.Now;
}